

con { timing }

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq               ' system freq as a constant
  MS_001   = CLK_FREQ / 1_000                                   ' ticks in 1ms
  US_001   = CLK_FREQ / 1_000_000                               ' ticks in 1us


con { io pins }

  RX1   = 31                                                    ' programming / terminal
  TX1   = 30
  
  SDA   = 29                                                    ' eeprom / i2c
  SCL   = 28

  ' *** Inputs ***
  
  I_KeyOn = 0 '14 ' 0                                           ' ignition on, pin 0 is in car, pin 14 is in the black box
  I_Rpm = 1                                             ' rpms input
  I_DIO =  6                                            ' mcp3204 input/output pins   
                                            '

  ' *** Outputs ***
  O_CLK =  5                                            ' mcp3204 clock pin 
  O_CS  =  7                                            ' mcp3204 chip select pins
  O_SimulateRpm = 15                                         ' rpm simulation code
  O_TempGauge = 16                                      ' temperature gauge pwm out                                                             


con { pst formatting }

  #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR
  #14, GOTOX, GOTOY, CLS

  
  ' universal constants

  clkFreqDivBy2 = (80000000/2)
  clkFreqDivBy3 = (80000000/3)
  clkFreqDivBy4 = (80000000/4)
  clkFreqDivBy5 = (80000000/5)
  clkFreqDivBy10 = (80000000/10)
  clkFreqDivBy20 = (80000000/20)
  clkFreqDivBy30 = (80000000/30)
  clkFreqDivBy40 = (80000000/40)
  clkFreqDivBy50 = (80000000/50)
  clkFreqDivBy100 = (80000000/100)
  clkFreqDivBy500 = (80000000/500)
  clkFreqDivBy1000 = (80000000/1000)
  clkFreqDivBy5000 = (80000000/5000)
  clkFreqDivBy10000 = (80000000/10000)

  clkFreqTimes1Point5 = (80000000 + (80000000/2))
  clkFreqTimes2 = (80000000 * 2)
  clkFreqTimes2Point5 = ((80000000 * 2) + (80000000/2))
  clkFreqTimes3 = (80000000 * 3)
  clkFreqTimes4 = (80000000 * 4)
  clkFreqTimes5 = (80000000 * 5)
  clkFreqTimes6 = (80000000 * 6)
  clkFreqTimes7 = (80000000 * 7)


  c_0FahrenheitOn = 99
  c_0FahrenheitOff = (100 - c_0FahrenheitOn)
  c_5FahrenheitOn = 99
  c_5FahrenheitOff = (100 - c_5FahrenheitOn) 
  c_10FahrenheitOn = 99
  c_10FahrenheitOff = (100 - c_10FahrenheitOn) 
  c_15FahrenheitOn = 99
  c_15FahrenheitOff = (100 - c_15FahrenheitOn) 
  c_20FahrenheitOn = 99
  c_20FahrenheitOff = (100 - c_20FahrenheitOn) 
  c_25FahrenheitOn = 99
  c_25FahrenheitOff = (100 - c_25FahrenheitOn) 
  c_30FahrenheitOn = 99
  c_30FahrenheitOff = (100 - c_30FahrenheitOn) 
  c_35FahrenheitOn = 99
  c_35FahrenheitOff = (100 - c_35FahrenheitOn) 
  c_40FahrenheitOn = 99
  c_40FahrenheitOff = (100 - c_40FahrenheitOn)
  c_45FahrenheitOn = 99
  c_45FahrenheitOff = (100 - c_45FahrenheitOn) 
  c_50FahrenheitOn = 99
  c_50FahrenheitOff = (100 - c_50FahrenheitOn) 
  c_55FahrenheitOn = 99
  c_55FahrenheitOff = (100 - c_55FahrenheitOn)
  c_60FahrenheitOn = 99
  c_60FahrenheitOff = (100 - c_60FahrenheitOn) 
  c_65FahrenheitOn = 99
  c_65FahrenheitOff = (100 - c_65FahrenheitOn) 
  c_70FahrenheitOn = 99
  c_70FahrenheitOff = (100 - c_70FahrenheitOn)
  c_75FahrenheitOn = 98
  c_75FahrenheitOff = (100 - c_75FahrenheitOn)
  c_80FahrenheitOn = 97
  c_80FahrenheitOff = (100 - c_80FahrenheitOn)
  c_85FahrenheitOn = 95
  c_85FahrenheitOff = (100 - c_85FahrenheitOn)
  c_90FahrenheitOn = 92
  c_90FahrenheitOff = (100 - c_90FahrenheitOn)
  c_95FahrenheitOn = 89
  c_95FahrenheitOff = (100 - c_95FahrenheitOn)
  c_100FahrenheitOn = 87
  c_100FahrenheitOff = (100 - c_100FahrenheitOn)
  c_105FahrenheitOn = 84
  c_105FahrenheitOff = (100 - c_105FahrenheitOn)
  c_110FahrenheitOn = 82
  c_110FahrenheitOff = (100 - c_110FahrenheitOn)
  c_115FahrenheitOn = 79
  c_115FahrenheitOff = (100 - c_115FahrenheitOn)
  c_120FahrenheitOn = 76
  c_120FahrenheitOff = (100 - c_120FahrenheitOn)
  c_125FahrenheitOn = 73
  c_125FahrenheitOff = (100 - c_125FahrenheitOn)
  c_130FahrenheitOn = 71
  c_130FahrenheitOff = (100 - c_130FahrenheitOn)
  c_135FahrenheitOn = 69
  c_135FahrenheitOff = (100 - c_135FahrenheitOn)
  c_140FahrenheitOn = 67
  c_140FahrenheitOff = (100 - c_140FahrenheitOn)
  c_145FahrenheitOn = 65
  c_145FahrenheitOff = (100 - c_145FahrenheitOn)
  c_150FahrenheitOn = 64
  c_150FahrenheitOff = (100 - c_150FahrenheitOn)
  c_155FahrenheitOn = 62
  c_155FahrenheitOff = (100 - c_155FahrenheitOn)
  c_160FahrenheitOn = 60
  c_160FahrenheitOff = (100 - c_160FahrenheitOn)
  c_165FahrenheitOn = 57
  c_165FahrenheitOff = (100 - c_165FahrenheitOn)
  c_170FahrenheitOn = 53
  c_170FahrenheitOff = (100 - c_170FahrenheitOn)
  c_175FahrenheitOn = 51
  c_175FahrenheitOff = (100 - c_175FahrenheitOn)
  c_180FahrenheitOn = 45
  c_180FahrenheitOff = (100 - c_180FahrenheitOn)
  c_185FahrenheitOn = 41
  c_185FahrenheitOff = (100 - c_185FahrenheitOn)
  c_190FahrenheitOn = 40
  c_190FahrenheitOff = (100 - c_190FahrenheitOn)
  c_195FahrenheitOn = 39
  c_195FahrenheitOff = (100 - c_195FahrenheitOn)
  c_200FahrenheitOn = 38
  c_200FahrenheitOff = (100 - c_200FahrenheitOn)
  c_205FahrenheitOn = 37
  c_205FahrenheitOff = (100 - c_205FahrenheitOn)
  c_210FahrenheitOn = 31
  c_210FahrenheitOff = (100 - c_210FahrenheitOn)
  c_215FahrenheitOn = 28
  c_215FahrenheitOff = (100 - c_215FahrenheitOn)
  c_220FahrenheitOn = 25
  c_220FahrenheitOff = (100 - c_220FahrenheitOn)
  c_225FahrenheitOn = 23
  c_225FahrenheitOff = (100 - c_225FahrenheitOn)
  c_230FahrenheitOn = 20
  c_230FahrenheitOff = (100 - c_230FahrenheitOn)
  c_235FahrenheitOn = 17
  c_235FahrenheitOff = (100 - c_235FahrenheitOn)
  c_240FahrenheitOn = 15
  c_240FahrenheitOff = (100 - c_240FahrenheitOn)
  c_245FahrenheitOn = 12
  c_245FahrenheitOff = (100 - c_245FahrenheitOn)
  c_250FahrenheitOn = 9
  c_250FahrenheitOff = (100 - c_250FahrenheitOn)
  c_255FahrenheitOn = 1
  c_255FahrenheitOff = (100 - c_255FahrenheitOn)
   

  c_minimalRunningRpm = 400
  'c_liftRpm = 5400
  'c_shiftRpm = 8300

  c_byteLimit = 100


obj

  debug : "fullduplexserial64"                                   ' use Parallax Serial Terminal
  adc  : "jm_mcp3208_ez"



var

  'pub main variables

  byte stringIn[c_byteLimit]
  long adcBits
  long adcMaxVoltage      
  long keyWaitForLow
  long keyPress1TimeStamp
  long keyPress2TimeStamp
  long keyPress3TimeStamp
  long keyPress4TimeStamp
  long trunkOpenOffTime
  long trunkSolenoidActive
  long windowOpenOffTime
  long windowRelayActive
  long mainDebug            
  long mainDebugPause
  long mainDebugPauseTime
  long i
  long adcTHWTempPrevious
  long adcTHWTemp
  long okToReadAdcTHW
'  long j 

  

  'pub coolantPwmOut variables

  long adcTHW
  long adcTHWPrevious
  long adcTHE
  long adcHP
  long adcUnknown
  long adcTPS
  long adcTHWBlock
  long onTime
  long offTime
  long coolantPwmDebug
  long coolantPwmDebugPause 
  long coolantPwmDebugPauseTime 
  long coolantPwmLastDebugTime1
  long coolantPwmLastDebugTime2
  long coolantPwmLastDebugTime3
  long airConditioningDebug
  long airConditioningNextOnTime 
  long airConditioningStateOff
  long airConditioningDebugPauseTime
  long airConditioningDebugPause
  long coolantPwmStateHigh 
  long coolantPwmOnTime
  long coolantPwmOffTime
  long coolantPwmDebugLoopOverride
  long airConDebugLoopOverride
  long firstRunAfterKeyOffCoolantPwm
  long adcRising
  long adcFalling
  long adcSimulateChangeRate

  byte coolantPwmOutCogId


  'long adc
  long adcOutputAsDecimal
  long adcOutputAsVoltage
  long pwmOutputHertzToClkCycles 


  ' Stack variables
  long coolantPwmOutStack[100]


  

pub main | t, ch, analog                            ' COG0 USED start main    


  waitcnt((clkfreq * 2) + cnt)

  coolantPwmOutCogId := Cognew(coolantPwmOut, @coolantPwmOutStack)        ' COG1 USED start coolantPwm

  debug.start(RX1, TX1, %0000, 115_200)             ' COG4 USED start terminal
  adc.start(O_CS, O_CLK, I_DIO)                     ' COG5 USED start adc driver
  adcBits := 4096
  adcMaxVoltage := 5

  ' initialization of variables
  t := cnt

  mainDebug := false
  mainDebugPause := cnt
  mainDebugPauseTime := clkFreqTimes2

  ' initialization of pins

  dira[I_KeyOn] ~               ' sets pin to input                                    
  dira[I_Rpm] ~                                         
  dira[I_DIO] ~


  ina[I_KeyOn] ~               ' sets the input low                                     
  ina[I_Rpm] ~                                                 
  ina[I_DIO] ~          


  
  dira[O_CS] ~~                                     ' Pin 5 ' sets the pin to output
  dira[O_CLK] ~~                                    ' Pin 7
  dira[O_SimulateRpm] := 1                          ' Pin 15
  dira[O_TempGauge] ~~                              ' Pin 16                                                                         

  outa[O_CLK] ~                                     ' Pin 5 ' output low
  outa[O_CS] ~                                      ' Pin 7
  outa[O_SimulateRpm] := 0                          ' Pin 15
  outa[O_TempGauge] ~                               ' Pin 16                                                                                     

  
  pwmOutputHertzToClkCycles := (((clkfreq) / 245) / 10) ' = 32653
  
  debug.tx(CLS) 
  debug.str(string("EMS Assistant"))
  debug.Tx(13)
  debug.str(string("Main"))
  debug.Tx(13)



  ' initialize variables

  i := 0
  okToReadAdcTHW := 1
  adcTHWTempPrevious := 3300
   

  repeat
 
    
    if (ina[I_KeyOn] == 1)

      if (coolantPwmOutCogId < 0) OR (coolantPwmOutCogId > 7) 
        coolantPwmOutCogId := Cognew(coolantPwmOut, @coolantPwmOutStack)        ' COG1 USED start coolantPwm


      if (okToReadAdcTHW == 1)
        okToReadAdcTHW := 0
        adcTHWTemp := adc.read(0, adc#SE)                 ' Potentiometer number 1

        
        if (adcTHWTemp <> 0)
          adcTHWTempPrevious := adcTHWTemp
          
        else
          adcTHWTemp := adcTHWTempPrevious


        okToReadAdcTHW := 1     


    else

      if (coolantPwmOutCogId > -1) 
        Cogstop(coolantPwmOutCogId)                       ' COG1 USED start coolantPwm
        coolantPwmOutCogId := -1
        outa[O_TempGauge] := 0                            ' Pin 16
        okToReadAdcTHW := 1
        debug.str(string(" *** Key is off (main)"))
      debug.tx(13)


    waitcnt((clkfreq/20) + cnt)    
      

pub coolantPwmOut 


  ' set pin states
  
  dira[I_KeyOn] := 0                                ' Pin 0 or 14
  dira[O_TempGauge] := 1                            ' Pin 16  ' output                            


  ' set pin voltages
            
  outa[O_TempGauge] := 0                            ' Pin 16
  
  ' initialize variables

  coolantPwmDebug := false
  coolantPwmDebugPause := cnt
  coolantPwmDebugPauseTime := clkFreqTimes2
  coolantPwmLastDebugTime1 := 0
  coolantPwmLastDebugTime2 := 0
  coolantPwmLastDebugTime3 := 0 
  coolantPwmStateHigh := false
  coolantPwmOnTime := cnt
  coolantPwmOffTime := cnt 
  adcTHWBlock := false

  waitcnt((clkfreq * 1) + cnt)
  
  repeat

    if (ina[I_KeyOn] == 1)
     
      if (okToReadAdcTHW == 1)
        okToReadAdcTHW := 0
        adcTHWPrevious := adcTHW
        adcTHW := adcTHWTemp                
        okToReadAdcTHW := 1

      debug.str(string("adcTHW is: "))
      debug.dec(adcTHW)
      debug.tx(13)  
       
      if (adcTHW <> 0)

        if (adcTHWBlock == false)
              
          case -1

            ((adcTHW < 4096) AND (adcTHW => 3350) AND (adcTHWBlock == false)):
                                ' (((32653          *     99) = 3232647) * 10) = 32326470
              onTime := ((pwmOutputHertzToClkCycles * c_70FahrenheitOn) * 10)
                                ' (((32653          *     1) = 32653) * 10) = 326530  
              offTime := ((pwmOutputHertzToClkCycles * c_70FahrenheitOff) * 10)
              
                                           ' changed from 910
            ((adcTHW < 3350) AND (adcTHW => 3250) AND (adcTHWBlock == false)):
                                ' (((32653          *     98) = 3199994) * 10) = 31999940 
              onTime := ((pwmOutputHertzToClkCycles * c_75FahrenheitOn) * 10)
                                ' (((32653          *     2) = 65306) * 10) = 653060
              offTime := ((pwmOutputHertzToClkCycles * c_75FahrenheitOff) * 10)
                          
                                           ' changed from 910
            ((adcTHW < 3250) AND (adcTHW => 3150) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_80FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_80FahrenheitOff) * 10)

                                                         
            ((adcTHW < 3150) AND (adcTHW => 3050) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_85FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_85FahrenheitOff) * 10)

                                                         
            ((adcTHW < 3050) AND (adcTHW => 2950) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_90FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_90FahrenheitOff) * 10)

                                                                       
            ((adcTHW < 2950) AND (adcTHW => 2850) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_95FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_95FahrenheitOff) * 10)

                                                                       
            ((adcTHW < 2850) AND (adcTHW => 2740) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_100FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_100FahrenheitOff) * 10)

                                                                       
            ((adcTHW < 2740) AND (adcTHW => 2625) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_105FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_105FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 2625) AND (adcTHW => 2530) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_110FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_110FahrenheitOff) * 10)
              
                                                                       
            ((adcTHW < 2530) AND (adcTHW => 2420) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_115FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_115FahrenheitOff) * 10)
              
                                                                       
            ((adcTHW < 2420) AND (adcTHW => 2330) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_120FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_120FahrenheitOff) * 10)
              
                                                                       
            ((adcTHW < 2330) AND (adcTHW => 2210) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_125FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_125FahrenheitOff) * 10)
              
                                                                       
            ((adcTHW < 2210) AND (adcTHW => 2120) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_130FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_130FahrenheitOff) * 10)  
 
                                                                       
            ((adcTHW < 2120) AND (adcTHW => 2010) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_135FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_135FahrenheitOff) * 10)  
              
                                                                       
            ((adcTHW < 2010) AND (adcTHW => 1915) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_140FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_140FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 1915) AND (adcTHW => 1810) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_145FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_145FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 1810) AND (adcTHW => 1715) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_150FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_150FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 1715) AND (adcTHW => 1605) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_155FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_155FahrenheitOff) * 10)  
                                                                        
                                                                       
            ((adcTHW < 1605) AND (adcTHW => 1490) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_160FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_160FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 1490) AND (adcTHW => 1400) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_165FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_165FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 1400) AND (adcTHW => 1300) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_170FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_170FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 1300) AND (adcTHW => 1225) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_175FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_175FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 1225) AND (adcTHW => 1160) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_180FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_180FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 1160) AND (adcTHW => 1075) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_185FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_185FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 1075) AND (adcTHW => 990) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_190FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_190FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 990) AND (adcTHW => 910) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_195FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_195FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 910) AND (adcTHW => 810) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_200FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_200FahrenheitOff) * 10)  
 
                                                                       
            ((adcTHW < 810) AND (adcTHW => 710) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_205FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_205FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 710) AND (adcTHW => 610) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_210FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_210FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 610) AND (adcTHW => 510) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_215FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_215FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 510) AND (adcTHW => 460) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_220FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_220FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 460) AND (adcTHW => 410) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_225FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_225FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 410) AND (adcTHW => 360) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_230FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_230FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 360) AND (adcTHW => 310) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_235FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_235FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 310) AND (adcTHW => 260) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_240FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_240FahrenheitOff) * 10)  

                                                                       
            ((adcTHW < 260) AND (adcTHW => 210) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_245FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_245FahrenheitOff) * 10)
              
                                                                       
            ((adcTHW < 210) AND (adcTHW => 160) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_250FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_250FahrenheitOff) * 10)
                
                                                                      
            ((adcTHW < 160) AND (adcTHW => 10) AND (adcTHWBlock == false)): 
              onTime := ((pwmOutputHertzToClkCycles * c_255FahrenheitOn) * 10)  
              offTime := ((pwmOutputHertzToClkCycles * c_255FahrenheitOff) * 10)

               

        
      if (coolantPwmStateHigh == false) AND ((cnt - coolantPwmOffTime) > 0)

        adcTHWBlock := true
        outa[O_TempGauge] := 1            
        coolantPwmOnTime := (onTime + cnt)
        coolantPwmStateHigh := true
    
           
      if (coolantPwmStateHigh == true) AND ((cnt - coolantPwmOnTime) > 0)

        adcTHWBlock := false
        outa[O_TempGauge] := 0
             
        coolantPwmOffTime := (offTime + cnt)
        coolantPwmStateHigh := false

      debug.str(string("pwmOutputHertzToClkCycles is: "))
      debug.dec(pwmOutputHertzToClkCycles)
      debug.tx(13)
      debug.str(string("onTime is: "))
      debug.dec(onTime)
      debug.tx(13)
      debug.str(string("offTime is: "))
      debug.dec(offTime)
      debug.tx(13)  

    else
        
      outa[O_TempGauge] := 0                            ' Pin 16
      adcTHWBlock := false
      okToReadAdcTHW := 1
      coolantPwmStateHigh := false
      coolantPwmOnTime := cnt
      coolantPwmOffTime := cnt          
      firstRunAfterKeyOffCoolantPwm := true

      debug.str(string(" *** Key is off (coolantPwm)"))
      debug.tx(13)
      
      waitcnt (clkfreq + cnt)

  